# AP4_StreamCipher Class Reference

`#include <Ap4StreamCipher.h>`

Inheritance diagram for AP4_StreamCipher:

List of all members.

## Public Types
enum | CipherDirection { ENCRYPT, DECRYPT }
## Public Member Functions
virtual | ~AP4_StreamCipher ()
virtual AP4_UI64 | GetStreamOffset ()=0
virtual AP4_Result | ProcessBuffer (const AP4_UI08 *in, AP4_Size in_size, AP4_UI08 *out, AP4_Size *out_size, bool is_last_buffer=false)=0
virtual AP4_Result | SetStreamOffset (AP4_UI64 offset, AP4_Cardinal *preroll)=0
virtual AP4_Result | SetIV (const AP4_UI08 *iv)=0
virtual const AP4_UI08 * | GetIV ()=0

## Detailed Description

Definition at line 48 of file Ap4StreamCipher.h.

## Member Enumeration Documentation

enum AP4_StreamCipher::CipherDirection

Enumerator:

  ENCRYPT |
  DECRYPT |

Definition at line 52 of file Ap4StreamCipher.h.

## Constructor & Destructor Documentation

virtual AP4_StreamCipher::~AP4_StreamCipher | ( |  | ) | `[inline, virtual]`

Definition at line 58 of file Ap4StreamCipher.h.

## Member Function Documentation

virtual AP4_UI64 AP4_StreamCipher::GetStreamOffset | ( |  | ) | `[pure virtual]`

Implemented in AP4_CtrStreamCipher, and AP4_CbcStreamCipher.

virtual AP4_Result AP4_StreamCipher::ProcessBuffer | ( | const AP4_UI08 * | in,
|  | AP4_Size | in_size,
|  | AP4_UI08 * | out,
|  | AP4_Size * | out_size,
|  | bool | is_last_buffer = `false` |
| ) |  |  | `[pure virtual]`

Implemented in AP4_CtrStreamCipher, and AP4_CbcStreamCipher.

virtual AP4_Result AP4_StreamCipher::SetStreamOffset | ( | AP4_UI64 | offset,
|  | AP4_Cardinal * | preroll |
| ) |  |  | `[pure virtual]`

Implemented in AP4_CtrStreamCipher, and AP4_CbcStreamCipher.

virtual AP4_Result AP4_StreamCipher::SetIV | ( | const AP4_UI08 * | iv | ) | `[pure virtual]`

Implemented in AP4_CtrStreamCipher, and AP4_CbcStreamCipher.

virtual const AP4_UI08* AP4_StreamCipher::GetIV | ( |  | ) | `[pure virtual]`

Implemented in AP4_CtrStreamCipher, and AP4_CbcStreamCipher.

The documentation for this class was generated from the following file:

- Ap4StreamCipher.h